#include <bits/stdc++.h>
typedef int_fast64_t lli;
using namespace std;
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    lli n, m;
    cin >> n >> m;
    vector<vector<lli> > G(n, vector<lli>(n, 0));
    vector<lli> vis(n, 0);
    for(lli i = 0, f, s; i < m; i++)
    {
        cin >> f >> s, f--, s--;
        G[f][s] = 1;
    }
    vector<lli> path;
    for(lli i = 0; i < n; i++) path.push_back(i);
    path.push_back(0);
    while(next_permutation(path.begin()+1, path.end()-1))
    {
        for(lli i = 0; i < path.size()-1; i++) if(!G[path[i]][path[i+1]]) goto label1;
        cout << "YES\n";
        for(auto& x : path) cout << x+1 << " ";
        return 0;
        label1:;
    }
    cout << "NO\n";
    return 0;
}
